scala.tools.nsc.CompilationUnits

# CompilationUnit

#### class CompilationUnit extends Global.CompilationUnitContextApi

One unit of compilation that has been submitted to the compiler. It typically corresponds to a single file of source code. It includes error-reporting hooks.

Self Type
  Global.CompilationUnit
Source
  CompilationUnits.scala

Linear Supertypes
Global.CompilationUnitContextApi, AnyRef, Any
Known Subclasses
NoCompilationUnit
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. CompilationUnit
2. CompilationUnitContextApi
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Instance Constructors

1. #### new CompilationUnit(source: SourceFile)

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Global.CompilationUnit to any2stringadd[Global.CompilationUnit] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Global.CompilationUnit, B)

   Implicit information
     This member is added by an implicit conversion from Global.CompilationUnit to ArrowAssoc[Global.CompilationUnit] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Definition Classes
     Any

7. #### var body: Global.Tree

   the content of the compilation unit in tree form

   the content of the compilation unit in tree form

   Definition Classes
     CompilationUnit → CompilationUnitContextApi

8. #### var checkedFeatures: Set[Global.Symbol]

   The features that were already checked for this unit

9. #### def clone(): AnyRef

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )

10. #### def defined: HashSet[Global.Symbol]

11. #### def depends: HashSet[Global.Symbol]

12. #### def encounteredXml(pos: Global.Position): Unit

    Record that we encountered XML.

    Record that we encountered XML. Should only be called once.

    Attributes
      protected[scala.tools.nsc]

13. #### def ensuring(cond: (Global.CompilationUnit) ⇒ Boolean, msg: ⇒ Any): Global.CompilationUnit

    Implicit information
      This member is added by an implicit conversion from Global.CompilationUnit to Ensuring[Global.CompilationUnit] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### def ensuring(cond: (Global.CompilationUnit) ⇒ Boolean): Global.CompilationUnit

    Implicit information
      This member is added by an implicit conversion from Global.CompilationUnit to Ensuring[Global.CompilationUnit] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

15. #### def ensuring(cond: Boolean, msg: ⇒ Any): Global.CompilationUnit

    Implicit information
      This member is added by an implicit conversion from Global.CompilationUnit to Ensuring[Global.CompilationUnit] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

16. #### def ensuring(cond: Boolean): Global.CompilationUnit

    Implicit information
      This member is added by an implicit conversion from Global.CompilationUnit to Ensuring[Global.CompilationUnit] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

17. #### final def eq(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

18. #### def equals(arg0: Any): Boolean

    Definition Classes
      AnyRef → Any

19. #### def exists: Boolean

20. #### def finalize(): Unit

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )

21. #### def firstXmlPos: Global.Position

    Position of first XML literal in this unit.

22. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Global.CompilationUnit to StringFormat[Global.CompilationUnit] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

23. #### implicit val fresh: FreshNameCreator

    the fresh name creator

24. #### def freshTermName(prefix: String = "x$"): Global.TermName

25. #### def freshTypeName(prefix: String): Global.TypeName

26. #### final def getClass(): Class[_]

    Definition Classes
      AnyRef → Any

27. #### def hasXml: Boolean

    Does this unit contain XML?

28. #### def hashCode(): Int

    Definition Classes
      AnyRef → Any

29. #### val icode: LinkedHashSet[Global.icodes.IClass]

    The icode representation of classes in this compilation unit.

    The icode representation of classes in this compilation unit. It is empty up to phase 'icode'.

30. #### final def isInstanceOf[T0]: Boolean

    Definition Classes
      Any

31. #### lazy val isJava: Boolean

    Is this about a .java source file?

32. #### final def ne(arg0: AnyRef): Boolean

    Definition Classes
      AnyRef

33. #### final def notify(): Unit

    Definition Classes
      AnyRef

34. #### final def notifyAll(): Unit

    Definition Classes
      AnyRef

35. #### def position(pos: Int): Position

36. #### val source: SourceFile

    Definition Classes
      CompilationUnit → CompilationUnitContextApi

37. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

38. #### object synthetics

    Synthetic definitions generated by namer, eliminated by typer.

39. #### def targetPos: Global.Position

    The position of a targeted type check If this is different from NoPosition, the type checking will stop once a tree that contains this position range is fully attributed.

40. #### val toCheck: ListBuffer[() ⇒ Unit]

    things to check at end of compilation unit

41. #### def toString(): String

    Definition Classes
      CompilationUnit → AnyRef → Any

42. #### val transformed: AnyRefMap[Global.Tree, Global.Tree]

43. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

46. #### def →[B](y: B): (Global.CompilationUnit, B)

    Implicit information
      This member is added by an implicit conversion from Global.CompilationUnit to ArrowAssoc[Global.CompilationUnit] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Deprecated Value Members

1. #### final def comment(pos: Global.Position, msg: String): Unit

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.2) This method will be removed. It does nothing.

2. #### final def deprecationWarning(pos: Global.Position, msg: String): Unit

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.2) Call global.currentRun.reporting.deprecationWarning directly instead.

3. #### final def echo(pos: Global.Position, msg: String): Unit

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.2) Call global.reporter.echo directly instead.

4. #### final def error(pos: Global.Position, msg: String): Unit

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.2) Call global.reporter.error (or typer.context.error) directly instead.

5. #### final def uncheckedWarning(pos: Global.Position, msg: String): Unit

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.2) Call global.currentRun.reporting.uncheckedWarning directly instead.

6. #### final def warning(pos: Global.Position, msg: String): Unit

   Annotations
     @deprecated
   Deprecated

     (Since version 2.11.2) Call global.reporter.warning (or typer.context.warning) directly instead.

### Inherited from Global.CompilationUnitContextApi

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Global.CompilationUnit to any2stringadd[Global.CompilationUnit]

### Inherited by implicit conversion StringFormat from Global.CompilationUnit to StringFormat[Global.CompilationUnit]

### Inherited by implicit conversion Ensuring from Global.CompilationUnit to Ensuring[Global.CompilationUnit]

### Inherited by implicit conversion ArrowAssoc from Global.CompilationUnit to ArrowAssoc[Global.CompilationUnit]

### Ungrouped